// FILENAME:	DM_Dueling_Haven.cs
//
// AUTHORS:  	*~Milliardo~* &  $EKA$Eagle
//------------------------------------------------------------------------------

$missionName = "DM_Dueling_Haven";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;
}

function onMissionStart(){
	titanSounds();
}
function vehicle::onDestroyed(%destroyed,%destroyer)
{
	%player = playerManager::vehicleIdToPlayerNum(%destroyed);
	reloadObject(%destroyer,10000);
	if (%player >0)
	{
		say(0,1,getHudName(%destroyer) @ " killed " @ getHudName(%destroyed));
		healObject(%destroyer,50000);
		healObject(%destroyer,20000);
		%destroyer.timeout = $time;
		%destroyed.timeout = $time;
		if (%destroyer.ziel == %destroyed)
		{
			%destroyer.ziel = 0;
		}
		%destroyed.ziel = 0;
		%destroyer.nziel = 0;
	}
}

function onMissionLoad()
{
   cdAudioCycle("Yougot");
   $server::TeamDamage = true;
   %ausgabe1 = "Welcome to Mill and Snowy's Place\n"
            @ "Our rules are:\n\n"
            @ "1) Duels means - ONE on ONE!!!!\n"
            @ "4) Don't start a fight shooting in your opponent's back.\n"
            @ "5) Let your opponent heal, reload and recharge before starting a fight.\n"
            @ "6) Don't use cheap weapons (sguns, plasma, missiles, also rads ).\n"
            @ "7) Please don't use profane language, there are kids who play this game, too.\n\n";
   %ausgabe2 = "<f5>NOTES<f3>:\n"
            @ "- An attacker will automatically be destroyed, if...\n"
            @ "  ...he and his opponent didn't scan each other before.\n"
            @ "  ...he tries to team or disturb a duel.\n"
            @ "\n"
            @ "Have fun!";
   setGameInfo(%ausgabe1 @ %ausgabe2);
   $irq = 1;
   interrupt();
}

function interrupt()
{
	$time++;
	if ($irq == 1)
	{
		schedule("interrupt();",1);
	}
}

function vehicle::onAttacked(%attacked,%attacker)
{
	if (%attacker.ziel != %attacked || %attacked.ziel != %attacker)
	{
		%a = playerManager::vehicleIdToPlayerNum(%attacked);
		%p = playerManager::vehicleIdToPlayerNum(%attacker);
		if ( %a > 0 && %p > 0 && %a != %p && (%attacker.timeout + 1 < $time))
		{
			healObject(%attacker,-50000);
			%attacker.timeout = $time;
			%a = getHudName(%attacker);
			%p = getHudName(%attacked);
			say(0,1,%a @ " started firing at " @ %p @ ", but has been destroyed because " @ %p @ " wasn't ready or had another fight");
			%player = playerManager::vehicleIdToPlayerNum(%attacker);
			messagebox(%player,"Your opponent wasn't ready or you teamed! Stop that!");
		}
	}
}

function vehicle::onScan(%scanned,%scanner)
{
	%a = getHudName(%scanner);
        %p = getHudName(%scanned);
	if (%scanner.nziel != %scanned && %scanner.ziel != %scanned)
	{
		if (%scanned.nziel != %scanner) // hat p schon a gescannt?
		{
			say(0,1,%a @ " wants to fight against " @ %p);
			%scanner.nziel = %scanned;
		}
		else
		{
			say(0,1,%a @ " vs. " @ %p @ "! Start fighting!");
			%scanner.ziel = %scanned;
			%scanned.ziel = %scanner;
			%scanner.nziel = 0;
			%scanned.nziel = 0;
		}
	}
}

function H1::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, -5079.64, -5424.09, 3.12595 ); 
}

function H2::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 2754.71, -3144.48, 2.5739 ); 
}

function H3::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, -695.82, 2974.71, 6.53861 ); 
}

function S1::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 1993.89, -2828.61, 71.7497 ); 
}

function S2::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 3251.59, -2327.41, 192.26 ); 
}

function S3::structure::onScan(%scanned, %scanner) 
{ 
  setPosition(%scanner, 3228.85, -3545.16, 305.241 ); 
}
