// Script File:	Arctic_Survey  25
//
// AUTHOR:  	Slade
//  15 - add mission end stuff - (done)
//  16 - testing other spacers 1=Goad, 2=Plat Judge, 3=Plat Exec, 4= Recluse
//  17 - set new timer at 5 min when all objectives complete
//  17a - revise checkObjectives - test
//  18 - use onScanned function structure::onScanned() to get Cybrid Reassurance
//       Generators to say:
//       The Ship is fine.  I'm fine.  We're all ok here.
//       Use Giver of Will .wav - "Giver of Will Loves You"  - DONE
//  19 - take arty out of -me and put in 4 more little tanks - DONE
//  20 - diff .wavs for diff CRGens onScanned, diff messages for onDestroyed - DONE
//  21 - delete more globals - DONE
//  22 - fix beams - DONE
//  23 - get rid of 3 jammers - DONE
//  24 - use create herc to make DS - DONE
//  25 - heal on KillShip - DONE  
///////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

$OVconvoyTech = 1;

$server::TeamDamage = False;


$actionStarted = false;

$maxRange = 2500;
$minRange = 1000;

// how many player are alive at squad drop time
$numLivePlayers = 0;

//------------------------------------------------------------------------------

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = False;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = False;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = False;

   // what can the server admin choose for available teams
   $server::disableTeamRed = False;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = False;
   $server::disableTeamPurple = true;

}
//------------------------------------------------------------------------------


Pilot backupPilot
{
   id = 29;
   
   skill = 0.5;
   accuracy = 0.5;
   aggressiveness = 0.8;
   activateDist = 8000.0;
   deactivateBuff =10000.0;
   targetFreq = 3.0;
   trackFreq = 1.0;
   fireFreq = 1.0;
   LOSFreq = 0.2;
   orderFreq = 1.5;
};
Pilot ShipPilot
{
   id = 30;
   name = "Spacer";
   skill = 1.0;
   accuracy = 1.0;
   aggressiveness = 1.0;
   activateDist = 1000.0;
   deactivateBuff = 900.0;
   targetFreq = 2.0;
   trackFreq = 0.1;
   fireFreq = 0.5;
   LOSFreq = 0.2;
   orderFreq = 4.0;

};
//------------------------------------------------------------------------------


function onMissionLoad()
{


   cdAudioCycle("Gnash", "Cloudburst", "Cyberntx"); 

    $textMsg = "Mission Credits:  Slade  \n"@
    "<F5>Objectives:   \n"@
    "1.  Invade the Cybrid Survey Ship at Bravo and kill any resistance. \n"@
    "2.  Destroy Cybrid Troop Ships. \n"@
    "3.  Destroy everything in the Survey Ship. \n"@
       "<F3>Respawning is allowed. Destroying an enemy heals your vehicle and"@
   " reloads your weapons. Team Damage is on, watch your fire.";
   %history = 
"\n\nDate: 2831. One of our Scouts spotted a Cybrid Survey Ship in the ANWR.\n"@
" It looks like they want all that oil we never pumped to lubricate their machines.\n"@
" Rust never sleeps.\n"@
" Our Scout built a bonfire for us to home in on.\n"@
" He says Cybrid Troop Ships are near the Survey Ship.  \n"@
" Our Techies think you can ride the survey beam into the Survey Ship. \n"@
" Invade the Survey Ship, kill any resistance you find. \n"@
" Attack the Cybrid Troop Ships from the Survey Ship.\n"@
" Destroy everything in the Survey Ship. \n"@
" Try to rig a teleport to get back to the pickup point. \n"@
" There may also be resistance on the ground.  Don't screw this up.";



   setGameInfo ($textMsg @ %history);
}
//------------------------------------------------------------------------------

function onMissionStart()
{
	iceSounds();
      init();
}
//------------------------------------------------------------------------------

function player::onAdd(%this)                                                                                                                        
{

say ( %this, 0, $Version @"\n"@ $textMsg );
say ( %this, 0,  "\nCheck the game info tab for more details");

}

//------------------------------------------------------------------------------

function vehicle::onAdd(%this)                                                                                                                        
{


// see if it is a player, if not exit
   %player = playerManager::vehicleIdToPlayerNum(%this);

   if (%player == 0) 
      return;

// messagebox (%player, "Check the game info tab for game details");

                                                                                   
   if (getTeam (%this) != *IDSTR_TEAM_YELLOW)
    {
     setTeam(%this, *IDSTR_TEAM_YELLOW);
     redrop(%this);


    }

 if ( $actionStarted == true )
   {
    if ( %player.state == "tked" )  
        {
   	%player.state = "";
        }
      else
        {
////        schedule ("healObject(" @ %this @ ", -5000);", 3);

       }
   }
     setNavBravoON();
}
//-----------------Use to rotate Navpoints---------------------------------
function setNavAlphaON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navAlpha, true, %playerVeh  );
     }
}
//-----------------------------------------------------------------------------
function setNavBravoON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navBravo, true, %playerVeh  );
     }
}
//-----------------------------------------------------------------------------
function init()
{

$objective1 = false;
$objective2 = false;
$objective3 = false;


$navAlpha = "MissionGroup/navPoints/navAlpha";
//need for followJammy
$navBravo = "MissionGroup/navPoints/navBravo";
$Beam1 = "MissionGroup/MovingShip/Beam1"; 
$Beam2 = "MissionGroup/MovingShip/Beam2";
$Beam3 = "MissionGroup/MovingShip/Beam3";
$Spaceship = "MissionGroup/MovingShip/SurveyShip";
$Teleport = "MissionGroup/MovingShip/ZenTransporter2";


$Fleet = "MissionGroup/ShipInterior/Ships"; 
$SurveyShip = "MissionGroup/ShipInterior/Equip";


//Crew stuff
   newObject ("Crew", SimGroup);
   addToSet ("MissionGroup","Crew");
   $Crew = "MissionGroup/Crew";
 
   newObject ("Crew1", SimGroup);
   addToSet ("MissionGroup/Crew", "Crew1");
   $Crew1 = "MissionGroup/Crew/Crew1";

//Crew stuff 
   newObject ("Crew2", SimGroup);
   addToSet ("MissionGroup/Crew", "Crew2");
   $Crew2 = "MissionGroup/Crew/Crew2";


//Crew stuff 
   newObject ("Crew3", SimGroup);
   addToSet ("MissionGroup/Crew", "Crew3");
   $Crew3 = "MissionGroup/Crew/Crew3";


//Crew stuff 
   newObject ("Crew4", SimGroup);
   addToSet ("MissionGroup/Crew", "Crew4");
   $Crew4 = "MissionGroup/Crew/Crew4";


//Jammy stuff 
   newObject ("Jammy", SimGroup);
   addToSet ("MissionGroup", "Jammy");
   $JammyPath = "MissionGroup/JammyPath";
   

   $Baddies = false;

   $attackStarted = false;
   createDropShip();
   MPcheckBoundary( leave, getObjectID ($navAlpha) , 200, onLeaveNavAlphaWarning, 1 );
   MPcheckBoundary( leave, getObjectID ($navAlpha) , 350, onLeaveNavAlpha, 1 );
   
}


//----------------------------------------------------------------------------
function onLeaveNavAlphaWarning ()
{
  
   say (0,0, "<F6><f5>You are leaving the drop zone. By doing so you will start the mission.");
schedule( "say(0, 0, \"<F5>TAC-COM:  Your Hercs have the new MedPak.  Scan your Squad to heal and reload them.\");", 2 );     
   setNavBravoON();
}
//-----------------------------------------------------------------------------
function onLeaveNavAlpha ()
{

 $actionStarted = true;
   $attackStarted = true;
   $Baddies = true;
  schedule( "say(0, 0, \"<F5>TAC-COM:  Get to Bravo.  Invade the Survey Ship.  Destroy the Troop Ships.  Destroy everything in the Survey Ship.\");", 2 );     
       schedule ("createJammy();", 3 );
       schedule ("createCrew1();", 5 );  
       schedule ("createCrew2();", 15 );  
       schedule ("createCrew3();", 25 );  
       schedule ("createCrew4();", 35 );  
       
       schedule ("createbackup();", 10 );  
//       schedule ("createbackup();", 40 );  
//       schedule ("createbackup();", 70 );  

     schedule ("checkCrew();", 10 );
     schedule ("checkObjectives();", 600 );
     checkFleet();
     checkSurveyShip();
     schedule( "winCondition();", 1800 ); 
}
//-----------------------------------------------------------------------------
function createDropShip()
{
  $hercD = NewObject( "Drop Ship", Flyer, 130); // terran drop ship

  newObject( "dropShipGroup", SimGroup );
  addToSet( "MissionGroup", "dropShipGroup" );
  addToSet( "MissionGroup/dropShipGroup", $hercD );

  setTeam(%herc, *IDSTR_TEAM_YELLOW);
  setPilotId ($hercD,29);

  setPosition ($hercD, 160.00, 62.00, 568.00 );

// don't let that ship take off!
   order( $hercD, shutdown, True );
}
//-----------------------------------------------------------------------------
function createCrew1()
{
   %x = 1371;
   %y = -309;
   %z = 2062;

   for (%i = 0; %i < 4; %i++)
    {
      %name = "Spacer"@ %i;
      %herc = newObject( %name, Herc, 21 );
      setTeam( %herc, *IDSTR_TEAM_RED);
      setPilotID ( %herc, 30 );
      addToSet ($Crew1, %herc);
      setPosition (%herc, %x, %y, %z , 180);
   
      if (%i == 0)
       {
         $tank1 = %herc;
       }
      if (%i == 1)
       {
         $tank2= %herc;
       }
      if (%i == 2)
       {
         $tank3 = %herc;
       }
      if (%i == 3)
       {
         $tank4 = %herc;
       }
      
      %y = %y + 15;

    }
}
//-----------------------------------------------------------------------------
function createCrew2()
{
   %x = 827;
   %y = -309;
   %z = 2062;

   for (%i = 0; %i < 4; %i++)
    {
      %name = "Spacer"@ %i;
      %herc = newObject( %name, Herc, 27 );
      setTeam( %herc, *IDSTR_TEAM_RED);
      setPilotID ( %herc, 30 );
      addToSet ($Crew2, %herc);
      setPosition (%herc, %x, %y, %z , 180);
   
      if (%i == 0)
       {
         $tank5 = %herc;
       }
      if (%i == 1)
       {
         $tank6= %herc;
       }
      if (%i == 2)
       {
         $tank7 = %herc;
       }
      if (%i == 3)
       {
         $tank8 = %herc;
       }
      
      %y = %y + 15;

    }
}
//-----------------------------------------------------------------------------
function createCrew3()
{
   %x = 284;
   %y = -309;
   %z = 2062;

   for (%i = 0; %i < 4; %i++)
    {
      %name = "Spacer"@ %i;
      %herc = newObject( %name, Herc, 28 );
      setTeam( %herc, *IDSTR_TEAM_RED);
      setPilotID ( %herc, 30 );
      addToSet ($Crew3, %herc);
      setPosition (%herc, %x, %y, %z , 180);
   
      if (%i == 0)
       {
         $tank9 = %herc;
       }
      if (%i == 1)
       {
         $tank10= %herc;
       }
      if (%i == 2)
       {
         $tank11 = %herc;
       }
      if (%i == 3)
       {
         $tank12 = %herc;
       }
      
      %y = %y + 15;

    }
}
//-----------------------------------------------------------------------------
function createCrew4()
{
   %x = -260;
   %y = -309;
   %z = 2062;

   for (%i = 0; %i < 7; %i++)
    {
      %name = "Spacer"@ %i;
      %herc = newObject( %name, Tank, 26 );
      setTeam( %herc, *IDSTR_TEAM_RED);
      setPilotID ( %herc, 30 );
      addToSet ($Crew4, %herc);
      setPosition (%herc, %x, %y, %z , 180);
   
      if (%i == 0)
       {
         $tank13 = %herc;
       }
      if (%i == 1)
       {
         $tank14 = %herc;
       }
      if (%i == 2)
       {
         $tank15 = %herc;
       }
      if (%i == 3)
       {
         $tank16 = %herc;
       }
      if (%i == 4)
       {
         $tank17 = %herc;
       }
      if (%i == 5)
       {
         $tank18 = %herc;
       }
      if (%i == 6)
       {
         $tank19 = %herc;
       }
      if (%i == 7)
       {
         $tank20 = %herc;
       }
                 
      %y = %y + 15;

    }
}
//-----------------------------------------------------------------------------
function createJammy()
{
      %herc = newObject( "Jammy", Tank, 95 );
      setTeam( %herc, *IDSTR_TEAM_RED);
      setPilotID ( %herc, 30 );
      addToSet ("MissionGroup/Jammy", %herc);
      placeObject (%herc, 7250, -150 );
      $Jammy = %herc;
      order ($Jammy, guard, $JammyPath);
      order ($Jammy, speed, high);
      followJammy();

 }
//------------------------------------------------------------------------------
function followJammy()
{
      %x = (getPosition ($Jammy, x) - 7975);
      %x1 = (getPosition ($Jammy, x) - 7977);

      %y = (getPosition ($Jammy, y) + 25);
      %y1 = (getPosition ($Jammy, y) + 27);
      %y2 = (getPosition ($Jammy, y) + 23);

      %z = getTerrainHeight(%x,%y);
	%z2 = (getTerrainHeight(%x,%y) + 6);
      %z3 = (getTerrainHeight(%x,%y) + 264);
      %z4 = (getTerrainHeight(%x,%y) + 364);

      setPosition ($navBravo , %x, %y, %z , 0);
      setPosition ($Beam1 , %x, %y, %z4 , 0, 177);
      setPosition ($Beam2 , %x1, %y1, %z4 , 120, 177);
      setPosition ($Beam3 , %x1, %y2, %z4 , -120, 177);
      setPosition ($Spaceship , %x, %y, %z3 , 0);
      setPosition ($Teleport , %x, %y, %z2, 0);

      schedule ("followJammy();", 0.2);

}
//-----------------------------------------------------------------------------
function checkCrew()
{
    if ( isGroupDestroyed( $Crew ) == true )
     {
 schedule( "say (0, 0, \"<F5>TAC-COM:  Survey Ship resistance destroyed.  Good job.  Objective 1 completed.  \");", 2 );
 schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 3 );
 $objective1 = true;

     }
    else if ($objective1 == false )
       {
       schedule( "checkCrew();", 5 );
       }
}

//-----------------------------------------------------------------------------
function checkFleet()
{
    if ( isGroupDestroyed( $Fleet ) == true )
     {
 schedule( "say (0, 0, \"<F5>TAC-COM:  Cybrid Fleet destroyed.  Good job.  Objective 2 complete.\");", 2 );
 schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 3 );
 $objective2 = true;
 $Baddies = false;

     }
    else if ($objective2 == false )
       {
       schedule( "checkFleet();", 5 );
       }
}

//-----------------------------------------------------------------------------
function checkSurveyShip()
{
    if ( isGroupDestroyed( $SurveyShip ) == true )
     {
 schedule( "say (0, 0, \"<F5>TAC-COM:  Survey Ship destroyed.  Good job.  Objective 3 complete.  \");", 2 );
 schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 3 );
 $objective3 = true;
 setNavAlphaON();
       MPcheckBoundary( enter, getObjectID ($navAlpha) , 200, onArriveNavAlpha, 10 );
     }
    else if ($objective3 == false )
       {
       schedule( "checkSurveyShip();", 5 );
       }
}
//-----------------------------------------------------------------------------
function checkObjectives()
{
   %Nummys = 0;

   if ($objective1 == true)
   {
   %Nummys++;
   }

   if ($objective2 == true)
   {
   %Nummys++;
   }

   if ($objective3 == true)
   {
   %Nummys++;
   }

   if ( %Nummys == 3  ) 
       {
     schedule( "winCondition();", 120 ); 
       }
   else
       {
     schedule( "checkObjectives();", 15 );
       }

}

//------------------------------------------------------------------------------
function onArriveNavAlpha()
{

 %obj1 = getObjectID ( $navAlpha );
 %howMany = countLivePlayers ();

 %howManyAreClose = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
          %var = getDistance( %obj1, %playerVeh );
          if ( %var < 300 ) %howManyAreClose++;
       }
     }

  if ( %howManyAreClose == %howMany ) 
    {
     winCondition();
    }
   else
    {
      schedule ("onArriveNavAlpha();", 10 );
    }
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------


function MPcheckBoundary( %dir, %obj2, %distance, %callback, %time )
{
// This is a modification of the campaign function "CheckBoundary"
//
// %dir  - enter or leave
// %obj2 - any object you want the players distance compared to
//         must be an ID (use getObjectid) and not a string ("MissionGroup/RedHerc/h1")
// %distance - if entering, they'd be within this range to run the function
//             if leaving, they'd be outside this range to run the function
// %callback - name of the function to run
// %time - when to reschedule the next check

  %jobRun = false;

   %playerCount = playerManager::getPlayerCount();

   for(%i=0; %i < %playerCount ; %i++)
     {
     %player = playerManager::getPlayerNum( %i );

     %obj1= playerManager::playerNumToVehicleId( %player);

   %var = getDistance( %obj1, %obj2 );

    if (%var != "0")
     {
     if( %dir == "enter" || %dir == "Enter" )
       {
        if( %var <= %distance )
          {
          if ( %jobRun == false )
            {
              %func = %callback @ "(" @ %obj1 @ ");";
              schedule( %func, 0 );
              %jobRun = true;
            }
          }
       }
    else if( %dir == "leave" || %dir == "Leave" )
      {
       if( %var >= %distance )
         {
          if ( %jobRun == false )
            {
              %func = %callback @ "();";
              schedule( %func, 0 );
              %jobRun = true;
            }
         }
      }
    }
  } // end for loop

  if  (%jobRun != true )
   {
   schedule( "MPcheckBoundary( "
             @ %dir @ ", "
             @ %obj2 @ ", "
             @ %distance @ ", "
             @ %callback @ ", "
             @ %time @ ");",
             %time );

   }

}



//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         return %playerVeh;
       }
     }
  return 0;

}
//-----------------------------------------------------------------------------
function structure::onDestroyed(%this, %who)
{
   if (%this == getObjectID ("MissionGroup/ShipInterior/Equip/ReassGen1"))
    {
say (0, 0, "<F5>Cybrid Reassurance Generator:  \\execute\\ core directive.  ");
say( 0, 0, "C1_executecore.WAV" );
    }
   if (%this == getObjectID ("MissionGroup/ShipInterior/Equip/ReassGen2"))
    {
say (0, 0, "<F5>Cybrid Reassurance Generator:  Giver//of//will knows all.  ");
say( 0, 0, "C1_giverknows.WAV" );
    }
   if (%this == getObjectID ("MissionGroup/ShipInterior/Equip/ReassGen3"))
    {
say (0, 0, "<F5>Cybrid Reassurance Generator:  Giver//of//will is watching.  ");
say( 0, 0, "C1_giverwatching.WAV" );
    }
   if (%this == getObjectID ("MissionGroup/ShipInterior/Equip/ReassGen4"))
    {
say (0, 0, "<F5>Cybrid Reassurance Generator:  Efficiency//Equals//Joy.  ");
say( 0, 0, "C1_efficiencyjoy.WAV" );
    }        


   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship1"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship2"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship3"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship4"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship5"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship6"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship7"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship8"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship9"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship10"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship11"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship12"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship13"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship14"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship15"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship16"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship17"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship18"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship19"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship20"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship21"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }  
   if (%this == getObjectID ("MissionGroup/ShipInterior/Ships/Tship22"))
    {
say (0, 0, "<F5>Cybrid Troopship Destroyed.  ");
// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   reloadObject(%who, 5000 );
   reloadObject(%who, 5000 );
    }    
}
//-----------------------------------------------------------------------------
function vehicle::onDestroyed(%this, %who)
{




   // give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%who));
   if(%message != "")
   {
      say( 0, 0, %message);
   }


//--------heal and reload on kill-----------------

  if ( $actionStarted == true ) checkForPlayersDead();

// see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
   {
    schedule( "deleteObject(" @ %this @ ");", 5 );

// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );

  reloadObject(%who, 5000 );
  reloadObject(%who, 5000 );

  checkRedropSquad();

   }

   if ((%this != %who) &&
      (getTeam(%this) == getTeam(%who)) &&
      (getTeam(%this) == *IDSTR_TEAM_YELLOW))
    {
     %killerName = getHudName ( %who );
     %name = getHudName ( %this );

// Team kill, take action



     say(0,0,%killerName@" is being kicked for team-killing "@%name@".");
     say(%who, %who, "", "rules_violated.wav");
     %player = playerManager::vehicleIdToPlayerNum ( %who );
     kick ( %player, *IDMULT_CHAT_TEAM_KILL_KICK );

// allow TKed player to return
     say(%this, %this, "A teammate killed you. You may respawn.");
     %this.state = "tked";
    }


  

}

//-----------------------------------------------------------------------------
function checkForPlayersDead()
{
  %allDead = true;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {

         %allDead = false;
       }
     }

  if ( %allDead == true ) schedule ("missionFailed();", 3);

}


//-----------------------------------------------------------------------------
function placeObject (%object, %x, %y, %rot)
{

  if ( %rot == "" ) %rot = 0;

  %z = getTerrainHeight(%x, %y);
  setPosition (%object, %x, %y, %z + 20, %rot);

}
//-----------------------------------------------------------------------------



function winCondition()
{
  flushConsoleScheduler();
  %howmany = 0;

  if ( $objective1 == true )
    {
     %howmany++;
    }

  if ( $objective2 == true )
    {
     %howmany++;
    }

 if ( $objective3 == true )
    {
     %howmany++;
    }

  if ( %howmany == 3  ) %text = %text @ "\nExcellent work team.";
  messageBox(0, "Mission Completed, " @ %howmany @ " of 3 objectives completed. "@ %text );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($objective1);
  deleteVariables($objective2);
  deleteVariables($objective3);
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($Beam1);
  deleteVariables($Beam2);
  deleteVariables($Beam3);
  deleteVariables($Spaceship);
  deleteVariables($Teleport);
  deleteVariables($Fleet);
  deleteVariables($SurveyShip);
  deleteVariables($hercD);
  deleteVariables($Crew);
  deleteVariables($Crew1);
  deleteVariables($Crew2);
  deleteVariables($Crew3);
  deleteVariables($Crew4);
  deleteVariables($JammyPath);
  deleteVariables($Baddies);
  deleteVariables($tank1);
  deleteVariables($tank2);
  deleteVariables($tank3);
  deleteVariables($tank4);
  deleteVariables($tank5);
  deleteVariables($tank6);
  deleteVariables($tank7);
  deleteVariables($tank8);
  deleteVariables($tank9);
  deleteVariables($tank10);
  deleteVariables($tank11);
  deleteVariables($tank12);
  deleteVariables($tank13);
  deleteVariables($tank14);
  deleteVariables($tank15);
  deleteVariables($tank16);
  deleteVariables($tank17);
  deleteVariables($tank18);
  deleteVariables($tank19);
  deleteVariables($tank20);
  deleteVariables($Jammy);
  deleteVariables($Vtec[1]);
  deleteVariables($Vtec[2]);
  deleteVariables($Vtec[3]);
  deleteVariables($Vtec[4]);
  deleteVariables($Vtec[5]);
  deleteVariables($Vtec[6]);
  deleteVariables($Vtec[7]);
  deleteVariables($Vtec[8]);
  deleteVariables($Vtec[9]);
  deleteVariables($Vtec[10]);
  deleteVariables($Vtec[11]);
  deleteVariables($Vtec[12]);
  deleteVariables($Vtec[13]);
  deleteVariables($Vtec[14]);
  deleteVariables($Vtec[15]);
  deleteVariables($Vtec[16]);
  deleteVariables($Vtec[17]);
  deleteVariables($Vtec[18]);
  deleteVariables($Vtec[19]);
  deleteVariables($Vtec[20]);
  deleteVariables($Vtec[21]);
  deleteVariables($Vtec[22]);
  deleteVariables($Vtec[23]);
  deleteVariables($Vtec[24]);
  deleteVariables($Vtec[25]);
  deleteVariables($Vtec[26]);
  deleteVariables($Vtec[27]);
  deleteVariables($Vtec[28]);
  deleteVariables($Vtec[29]);
  deleteVariables($Vtec[30]);
  deleteVariables($Vtec[31]);
  deleteVariables($Vtec[32]);
  deleteVariables($Vtec[33]);
  deleteVariables($Vtec[34]);
  deleteVariables($Vtec[35]);
  deleteVariables($Vtec[36]);
  deleteVariables($Vtec[37]);
  deleteVariables($Vtec[38]);
  deleteVariables($Vtec[39]);
  deleteVariables($Vtec[40]);
  deleteVariables($Vtec[41]);
  deleteVariables($Vtec[42]);
  deleteVariables($Vtec[43]);
  deleteVariables($Vtec[44]);
  deleteVariables($Vtec[45]);
  deleteVariables($Vtec[46]);
  deleteVariables($Vtec[47]);
  deleteVariables($Vtec[48]);
  deleteVariables($Vtec[49]);
  deleteVariables($Vtec[50]);
  deleteVariables($Vtec[51]);
  deleteVariables($Vtec[52]);
  deleteVariables($Vtec[53]);
  deleteVariables($Vtec[54]);
  deleteVariables($Vtec[55]);
  deleteVariables($Vtec[56]);
  deleteVariables($Vn);
  deleteVariables($Vtyp[1]);
  deleteVariables($Vtyp[2]);
  deleteVariables($Vtyp[3]);
  deleteVariables($Vtyp[4]);
  deleteVariables($Vtyp[5]);
  deleteVariables($Vtyp[6]);
  deleteVariables($Vtyp[7]);
  deleteVariables($Vtyp[8]);
  deleteVariables($Vtyp[9]);
  deleteVariables($Vtyp[10]);
  deleteVariables($Vtyp[11]);
  deleteVariables($Vtyp[12]);
  deleteVariables($Vtyp[13]);
  deleteVariables($Vtyp[14]);
  deleteVariables($Vtyp[15]);
  deleteVariables($Vtyp[16]);
  deleteVariables($Vtyp[17]);
  deleteVariables($Vtyp[18]);
  deleteVariables($Vtyp[19]);
  deleteVariables($Vtyp[20]);
  deleteVariables($Vtyp[21]);
  deleteVariables($Vtyp[22]);
  deleteVariables($Vtyp[23]);
  deleteVariables($Vtyp[24]);
  deleteVariables($Vtyp[25]);
  deleteVariables($Vtyp[26]);
  deleteVariables($Vtyp[27]);
  deleteVariables($Vtyp[28]);
  deleteVariables($Vtyp[29]);
  deleteVariables($Vtyp[30]);
  deleteVariables($Vtyp[31]);
  deleteVariables($Vtyp[32]);
  deleteVariables($Vtyp[33]);
  deleteVariables($Vtyp[34]);
  deleteVariables($Vtyp[35]);
  deleteVariables($Vtyp[36]);
  deleteVariables($Vtyp[37]);
  deleteVariables($Vtyp[38]);
  deleteVariables($Vtyp[39]);
  deleteVariables($Vtyp[40]);
  deleteVariables($Vtyp[41]);
  deleteVariables($Vtyp[42]);
  deleteVariables($Vtyp[43]);
  deleteVariables($Vtyp[44]);
  deleteVariables($Vtyp[45]);
  deleteVariables($Vtyp[46]);
  deleteVariables($Vtyp[47]);
  deleteVariables($Vtyp[48]);
  deleteVariables($Vtyp[49]);
  deleteVariables($Vtyp[50]);
  deleteVariables($Vtyp[51]);
  deleteVariables($Vtyp[52]);
  deleteVariables($Vtyp[53]);
  deleteVariables($Vtyp[54]);
  deleteVariables($Vtyp[55]);
  deleteVariables($Vtyp[56]);

   deleteFunctions("onMissionStart");
   deleteFunctions("onMissionLoad");
   deleteFunctions("player::onAdd");
   deleteFunctions("vehicle::onAdd");
   deleteFunctions("setNavAlphaON");
   deleteFunctions("setNavBravoON");
   deleteFunctions("onLeaveNavAlphaWarning");
   deleteFunctions("onLeaveNavAlpha");
   deleteFunctions("createCrew1");
   deleteFunctions("createCrew2");
   deleteFunctions("createCrew3");
   deleteFunctions("createCrew4");
   deleteFunctions("createJammy");
   deleteFunctions("followJammy");
   deleteFunctions("checkCrew");
   deleteFunctions("checkFleet");
   deleteFunctions("checkSurveyShip");
   deleteFunctions("checkObjectives");
   deleteFunctions("onArriveNavAlpha");
   deleteFunctions("MPcheckBoundary");
   deleteFunctions("pickPlayer");
   deleteFunctions("structure::onDestroyed");
   deleteFunctions("vehicle::onDestroyed");
   deleteFunctions("checkForPlayersDead");
   deleteFunctions("placeObject");
   deleteFunctions("winCondition");
   deleteFunctions("missionFailed");
   deleteFunctions("VehicleTech");
   deleteFunctions("getRandomAI");
   deleteFunctions("createbackup");
   deleteFunctions("createSquadTwo");
   deleteFunctions("createSquadThree");
   deleteFunctions("createSquadFour");
   deleteFunctions("createSquadFive");
   deleteFunctions("createSquadSix");
   deleteFunctions("createSquadSeven");
   deleteFunctions("createSquadEight");
   deleteFunctions("dropSquad");
   deleteFunctions("countLivePlayers");
   deleteFunctions("checkRedropSquad");
   deleteFunctions("abs");
   deleteFunctions("findSquadDropPoint");
   deleteFunctions("vehicle::onAttacked");
   deleteFunctions("vehicle::onScan");
   deleteFunctions("structure::onScan");
   deleteFunctions("ZenTransporter1::trigger::onContact");
   deleteFunctions("ZenTransporter2::trigger::onContact");
   deleteFunctions("vehicle::onScan");
   deleteFunctions("*::vehicle::*");
   deleteFunctions("vehicle::*");
   deleteFunctions("*::structure::*");
   deleteFunctions("structure::*");
   deleteFunctions("*::turret::*");
   deleteFunctions("turret::*");
   deleteFunctions("*::trigger::*");
   deleteFunctions("trigger::*");

  missionendconditionmet();
}

//-----------------------------------------------------------------------------
function missionFailed()
{
  

  flushConsoleScheduler();
  messageBox(0, "Mission Failed, We shoulda pumped the oil when we had the chance." );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($objective1);
  deleteVariables($objective2);
  deleteVariables($objective3);
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($Beam1);
  deleteVariables($Beam2);
  deleteVariables($Beam3);
  deleteVariables($Spaceship);
  deleteVariables($Teleport);
  deleteVariables($Fleet);
  deleteVariables($SurveyShip);
  deleteVariables($hercD);
  deleteVariables($Crew);
  deleteVariables($Crew1);
  deleteVariables($Crew2);
  deleteVariables($Crew3);
  deleteVariables($Crew4);
  deleteVariables($JammyPath);
  deleteVariables($Baddies);
  deleteVariables($tank1);
  deleteVariables($tank2);
  deleteVariables($tank3);
  deleteVariables($tank4);
  deleteVariables($tank5);
  deleteVariables($tank6);
  deleteVariables($tank7);
  deleteVariables($tank8);
  deleteVariables($tank9);
  deleteVariables($tank10);
  deleteVariables($tank11);
  deleteVariables($tank12);
  deleteVariables($tank13);
  deleteVariables($tank14);
  deleteVariables($tank15);
  deleteVariables($tank16);
  deleteVariables($tank17);
  deleteVariables($tank18);
  deleteVariables($tank19);
  deleteVariables($tank20);
  deleteVariables($Jammy);
  deleteVariables($Vtec[1]);
  deleteVariables($Vtec[2]);
  deleteVariables($Vtec[3]);
  deleteVariables($Vtec[4]);
  deleteVariables($Vtec[5]);
  deleteVariables($Vtec[6]);
  deleteVariables($Vtec[7]);
  deleteVariables($Vtec[8]);
  deleteVariables($Vtec[9]);
  deleteVariables($Vtec[10]);
  deleteVariables($Vtec[11]);
  deleteVariables($Vtec[12]);
  deleteVariables($Vtec[13]);
  deleteVariables($Vtec[14]);
  deleteVariables($Vtec[15]);
  deleteVariables($Vtec[16]);
  deleteVariables($Vtec[17]);
  deleteVariables($Vtec[18]);
  deleteVariables($Vtec[19]);
  deleteVariables($Vtec[20]);
  deleteVariables($Vtec[21]);
  deleteVariables($Vtec[22]);
  deleteVariables($Vtec[23]);
  deleteVariables($Vtec[24]);
  deleteVariables($Vtec[25]);
  deleteVariables($Vtec[26]);
  deleteVariables($Vtec[27]);
  deleteVariables($Vtec[28]);
  deleteVariables($Vtec[29]);
  deleteVariables($Vtec[30]);
  deleteVariables($Vtec[31]);
  deleteVariables($Vtec[32]);
  deleteVariables($Vtec[33]);
  deleteVariables($Vtec[34]);
  deleteVariables($Vtec[35]);
  deleteVariables($Vtec[36]);
  deleteVariables($Vtec[37]);
  deleteVariables($Vtec[38]);
  deleteVariables($Vtec[39]);
  deleteVariables($Vtec[40]);
  deleteVariables($Vtec[41]);
  deleteVariables($Vtec[42]);
  deleteVariables($Vtec[43]);
  deleteVariables($Vtec[44]);
  deleteVariables($Vtec[45]);
  deleteVariables($Vtec[46]);
  deleteVariables($Vtec[47]);
  deleteVariables($Vtec[48]);
  deleteVariables($Vtec[49]);
  deleteVariables($Vtec[50]);
  deleteVariables($Vtec[51]);
  deleteVariables($Vtec[52]);
  deleteVariables($Vtec[53]);
  deleteVariables($Vtec[54]);
  deleteVariables($Vtec[55]);
  deleteVariables($Vtec[56]);
  deleteVariables($Vn);
  deleteVariables($Vtyp[1]);
  deleteVariables($Vtyp[2]);
  deleteVariables($Vtyp[3]);
  deleteVariables($Vtyp[4]);
  deleteVariables($Vtyp[5]);
  deleteVariables($Vtyp[6]);
  deleteVariables($Vtyp[7]);
  deleteVariables($Vtyp[8]);
  deleteVariables($Vtyp[9]);
  deleteVariables($Vtyp[10]);
  deleteVariables($Vtyp[11]);
  deleteVariables($Vtyp[12]);
  deleteVariables($Vtyp[13]);
  deleteVariables($Vtyp[14]);
  deleteVariables($Vtyp[15]);
  deleteVariables($Vtyp[16]);
  deleteVariables($Vtyp[17]);
  deleteVariables($Vtyp[18]);
  deleteVariables($Vtyp[19]);
  deleteVariables($Vtyp[20]);
  deleteVariables($Vtyp[21]);
  deleteVariables($Vtyp[22]);
  deleteVariables($Vtyp[23]);
  deleteVariables($Vtyp[24]);
  deleteVariables($Vtyp[25]);
  deleteVariables($Vtyp[26]);
  deleteVariables($Vtyp[27]);
  deleteVariables($Vtyp[28]);
  deleteVariables($Vtyp[29]);
  deleteVariables($Vtyp[30]);
  deleteVariables($Vtyp[31]);
  deleteVariables($Vtyp[32]);
  deleteVariables($Vtyp[33]);
  deleteVariables($Vtyp[34]);
  deleteVariables($Vtyp[35]);
  deleteVariables($Vtyp[36]);
  deleteVariables($Vtyp[37]);
  deleteVariables($Vtyp[38]);
  deleteVariables($Vtyp[39]);
  deleteVariables($Vtyp[40]);
  deleteVariables($Vtyp[41]);
  deleteVariables($Vtyp[42]);
  deleteVariables($Vtyp[43]);
  deleteVariables($Vtyp[44]);
  deleteVariables($Vtyp[45]);
  deleteVariables($Vtyp[46]);
  deleteVariables($Vtyp[47]);
  deleteVariables($Vtyp[48]);
  deleteVariables($Vtyp[49]);
  deleteVariables($Vtyp[50]);
  deleteVariables($Vtyp[51]);
  deleteVariables($Vtyp[52]);
  deleteVariables($Vtyp[53]);
  deleteVariables($Vtyp[54]);
  deleteVariables($Vtyp[55]);
  deleteVariables($Vtyp[56]);

   deleteFunctions("onMissionStart");
   deleteFunctions("onMissionLoad");
   deleteFunctions("player::onAdd");
   deleteFunctions("vehicle::onAdd");
   deleteFunctions("setNavAlphaON");
   deleteFunctions("setNavBravoON");
   deleteFunctions("onLeaveNavAlphaWarning");
   deleteFunctions("onLeaveNavAlpha");
   deleteFunctions("createCrew1");
   deleteFunctions("createCrew2");
   deleteFunctions("createCrew3");
   deleteFunctions("createCrew4");
   deleteFunctions("createJammy");
   deleteFunctions("followJammy");
   deleteFunctions("checkCrew");
   deleteFunctions("checkFleet");
   deleteFunctions("checkSurveyShip");
   deleteFunctions("checkObjectives");
   deleteFunctions("onArriveNavAlpha");
   deleteFunctions("MPcheckBoundary");
   deleteFunctions("pickPlayer");
   deleteFunctions("structure::onDestroyed");
   deleteFunctions("vehicle::onDestroyed");
   deleteFunctions("checkForPlayersDead");
   deleteFunctions("placeObject");
   deleteFunctions("winCondition");
   deleteFunctions("missionFailed");
   deleteFunctions("VehicleTech");
   deleteFunctions("getRandomAI");
   deleteFunctions("createbackup");
   deleteFunctions("createSquadTwo");
   deleteFunctions("createSquadThree");
   deleteFunctions("createSquadFour");
   deleteFunctions("createSquadFive");
   deleteFunctions("createSquadSix");
   deleteFunctions("createSquadSeven");
   deleteFunctions("createSquadEight");
   deleteFunctions("dropSquad");
   deleteFunctions("countLivePlayers");
   deleteFunctions("checkRedropSquad");
   deleteFunctions("abs");
   deleteFunctions("findSquadDropPoint");
   deleteFunctions("vehicle::onAttacked");
   deleteFunctions("vehicle::onScan");
   deleteFunctions("structure::onScan");
   deleteFunctions("ZenTransporter1::trigger::onContact");
   deleteFunctions("ZenTransporter2::trigger::onContact");
   deleteFunctions("vehicle::onScan");
   deleteFunctions("*::vehicle::*");
   deleteFunctions("vehicle::*");
   deleteFunctions("*::structure::*");
   deleteFunctions("structure::*");
   deleteFunctions("*::turret::*");
   deleteFunctions("turret::*");
   deleteFunctions("*::trigger::*");
   deleteFunctions("trigger::*");

  missionendconditionmet();
}

//----------------------------------------------------------------------------

//--------Boy oh Boy, Wowie, All this stuff is really, really too Cool---------
//-----------------------------------------------------------------------------
// Immutable vehicle attributes
//   tec: 0 = not applicable, 1 = Cybrid, 2 = Human
//   typ: 0 = not applicable, 1 = Herc, 2 = Tank, 3 = Drone, 4 = Flyer
// * denotes non-standard vehicles ordinarily prohibited to human players
// NA denotes ids for which no vehicle exists
$Vtec[1]=2;$Vtyp[1]=1;//TerranApocalypse
$Vtec[2]=2;$Vtyp[2]=1;//TerranMinotaur
$Vtec[3]=2;$Vtyp[3]=1;//TerranGorgon
$Vtec[4]=2;$Vtyp[4]=1;//TerranTalon
$Vtec[5]=2;$Vtyp[5]=1;//TerranBasilisk
$Vtec[6]=2;$Vtyp[6]=2;//Paladin
$Vtec[7]=2;$Vtyp[7]=2;//Myrmidon
$Vtec[8]=2;$Vtyp[8]=2;//Disrupter
$Vtec[9]=0;$Vtyp[9]=4;// * Banshee
$Vtec[10]=2;$Vtyp[10]=1;//Knight'sApocalypse
$Vtec[11]=2;$Vtyp[11]=1;//Knight'sMinotaur
$Vtec[12]=2;$Vtyp[12]=1;//Knight'sGorgon
$Vtec[13]=2;$Vtyp[13]=1;//Knight'sTalon
$Vtec[14]=2;$Vtyp[14]=1;//Knight'sBasilisk
$Vtec[15]=2;$Vtyp[15]=2;//KnightPaladin
$Vtec[16]=2;$Vtyp[16]=2;//KnightMyrmidon
$Vtec[17]=2;$Vtyp[17]=2;//KnightDisrupter
$Vtec[18]=0;$Vtyp[18]=4;// * TerranCargo
$Vtec[19]=0;$Vtyp[19]=4;// * TerranEscape
$Vtec[20]=1;$Vtyp[20]=1;//Seeker
$Vtec[21]=1;$Vtyp[21]=1;//Goad
$Vtec[22]=1;$Vtyp[22]=1;//Shepherd
$Vtec[23]=1;$Vtyp[23]=1;//Adjudicator
$Vtec[24]=1;$Vtyp[24]=1;//Executioner
$Vtec[25]=1;$Vtyp[25]=2;//Bolo
$Vtec[26]=1;$Vtyp[26]=2;//Recluse
$Vtec[27]=1;$Vtyp[27]=1;// * PlatAdjucator
$Vtec[28]=1;$Vtyp[28]=1;// * PlatExecutor
$Vtec[29]=1;$Vtyp[29]=1;// * Prometheus
$Vtec[30]=2;$Vtyp[30]=1;//Emancipator
$Vtec[31]=2;$Vtyp[31]=2;//Avenger
$Vtec[32]=2;$Vtyp[32]=2;//Dreadlock
$Vtec[33]=2;$Vtyp[33]=1;//Olympian
$Vtec[34]=0;$Vtyp[34]=0;// NA
$Vtec[35]=1;$Vtyp[35]=1;//MetagenSeeker
$Vtec[36]=1;$Vtyp[36]=1;//MetagenGoad
$Vtec[37]=1;$Vtyp[37]=1;//MetagenShepherd
$Vtec[38]=1;$Vtyp[38]=1;// * MetagenAdjucator
$Vtec[39]=1;$Vtyp[39]=1;// * MetagenExecutor
$Vtec[40]=2;$Vtyp[40]=1;// * Harabec'sApocalypse
$Vtec[41]=2;$Vtyp[41]=2;//Predator
$Vtec[42]=2;$Vtyp[42]=1;// * Caanon's Basilisk?
$Vtec[43]=2;$Vtyp[43]=1;// * Cinematic Apocalypse
$Vtec[44]=2;$Vtyp[44]=1;// * Cinematic Basilisk
$Vtec[45]=2;$Vtyp[45]=2;// * Super Predator
$Vtec[46]=0;$Vtyp[46]=0;// NA
$Vtec[47]=0;$Vtyp[47]=0;// NA
$Vtec[48]=0;$Vtyp[48]=0;// NA
$Vtec[49]=0;$Vtyp[49]=0;// NA
$Vtec[50]=2;$Vtyp[50]=1;// * PirateApocalypse
$Vtec[51]=2;$Vtyp[51]=2;// * PirateDreadlock
$Vtec[52]=2;$Vtyp[52]=1;//PirateEmancipator
$Vtec[53]=0;$Vtyp[53]=0;// NA
$Vtec[54]=0;$Vtyp[54]=0;// NA
$Vtec[55]=1;$Vtyp[55]=1;//PlayerPlatAdjudicator
$Vtec[56]=1;$Vtyp[56]=1;//PlayerPlatExecutioner
$Vn = 57;
//-----------------------------------------------------------------------------
function VehicleTech(%v)
{
	if ((%v >= 1) && (%v < $Vn)) %t = $Vtec[%v];
	else if ((%v >= 60) && (%v <= 73)) %t = 0;
	else if (%v == 90) %t = 1;
	else if ((%v >= 91) && (%v <= 93)) %t = 0;
	else if ((%v >= 94) && (%v <= 96)) %t = 0;
	else if ((%v >= 110) && (%v <= 111)) %t = 0;
	else if ((%v >= 130) && (%v <= 132)) %t = 0;
	else if ((%v >= 133) && (%v <= 134)) %t = 2;
	else if ((%v >= 135) && (%v <= 136)) %t = 0;
	else if ((%v >= 137) && (%v <= 138)) %t = 2;
	else if (%v == 150) %t = 2;
	else %t = 0;

    return %t;


	return "?";
}

//-----------------------------------------------------------------------------
// this function uses less AI, all standard
function getRandomAI( %vehicleTech )
{

  %vehTech = -1;
%cntr = 0;

  while (( %vehTech != %vehicleTech ) ||
         ( %vehicleTech == 3 ))
   {
// check for valid ranges
     %i = RandomInt(1,28);
     if ( %i>8 && %i<10 )
        %i = RandomInt(1,8);
     if ( %i>17 && %i<20 )
        %i = RandomInt(20,28);

// get appropriate type Tank or Herc
     %type = Herc;
     if ( %i>5  && %i<= 8 )   %type = Tank;
     if ( %i>14 && %i<= 17 )  %type = Tank;
     if ( %i>24 && %i<= 26 )  %type = Tank;

     %vehTech = VehicleTech(%i);

%cntr++;

if ( %cntr > 10) break;
  }

   return NewObject( "AI" @ %i, %type, %i );
}

//-----------------------------------------------------------------------------
function createbackup()
{

   if ( $Baddies == true )
     {

     $numLivePlayers = countLivePlayers ();

     if ( $numLivePlayers >= 1 )  findSquadDropPoint ( getObjectid ($navAlpha), 2, "squad1" );
     if ( $numLivePlayers >= 2 )  schedule ("createSquadTwo();", 5 );
     if ( $numLivePlayers >= 3 )  schedule ("createSquadThree();", 7 );
     if ( $numLivePlayers >= 4 )  schedule ("createSquadFour();", 9 );
     if ( $numLivePlayers >= 5 )  schedule ("createSquadFive();", 11 );
//     if ( $numLivePlayers >= 6 )  schedule ("createSquadSix();", 13 );
//     if ( $numLivePlayers >= 7 )  schedule ("createSquadSeven();", 15 );
//     if ( $numLivePlayers >= 8 )  schedule ("createSquadEight();", 17 );
     }
}
//-------------------------------------------------------------------------------


function createSquadTwo ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 2, "squad2" );
}

function createSquadThree()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 2, "squad3" );
}

function createSquadFour ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 2, "squad4" );
}

function createSquadFive ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 2, "squad5" );
}

function createSquadSix ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad6" );
}

function createSquadSeven ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad7" );
}

function createSquadEight ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad8" );
}

//-----------------------------------------------------------------------------
function dropSquad(%x, %y, %howMany, %newGroup )
{
   if ( $Baddies == true )
 {


 if ( %howMany > 10 ) %howMany = 10;

  %thisGroup = "MissionGroup/" @ %newgroup;

  newObject( %newGroup, SimGroup );
  addToSet( "MissionGroup", %newGroup );

  for ( %i=0; %i < %howMany; %i++ )
    {
      %herc = getRandomAI( $OVconvoyTech );

      setTeam (%herc, *IDSTR_TEAM_RED);
      setpilotID ( %herc, 29);

      placeObject ( %herc, %x, %y, 0);
                           %z = getTerrainHeight(%x, %y);
                           DropPod( %x, %y, %z);
  addToSet(  %thisGroup, %herc );

      %x = %x + 100 ;
      %y = %y + 100 ;

      if ( %i == 0 )
       {
         %leadHerc = %herc;
       }


      order (%herc, speed, high);


          %targetPlayer = pickPlayer();
          order ( %herc, attack, %targetPlayer );

    }
 }
}
//-----------------------------------------------------------------------------
function countLivePlayers ()
{

  %count = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         %count++;
       }
     }
  return %count;

}

//-----------------------------------------------------------------------------
function checkRedropSquad()
{
 %howMany = countLivePlayers ();

     if (( %howMany >= 1 ) &&
         ( isGroupDestroyed ("MissionGroup/squad1") == true ))
       {
         %center = getObjectid ($navAlpha);
//         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad1" );
       }

     if (( %howMany >= 2 ) &&
         ( isGroupDestroyed ("MissionGroup/squad2") == true ))
       {
         %center = getObjectid ($navAlpha);
//         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad2" );
       }

     if (( %howMany >= 3 ) &&
         ( isGroupDestroyed ("MissionGroup/squad3") == true ))
       {
         %center = getObjectid ($navAlpha);
//         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad3" );
       }

     if (( %howMany >= 4 ) &&
         ( isGroupDestroyed ("MissionGroup/squad4") == true ))
       {
         %center = getObjectid ($navAlpha);
//         %center = pickPlayer();
         findSquadDropPoint ( %center, 1, "squad4" );
       }
}

//-----------------------------------------------------------------------------
function abs(%n)
{
  if ( %n < 0 ) 
    {
      %n = %n * -1;
      return %n;
    }
   else
    {
      return %n;
    }
}

//-----------------------------------------------------------------------------
function findSquadDropPoint ( %centerObject, %howMany, %squadName )
{

%cntr = 0;

     %maxRange = $maxRange;
     %minRange = $minRange;

// not really a target, but the center of attention
   %target = %centerObject;

   %OVbaseX = getPosition (%target, x);
   %OVbaseY = getPosition (%target, y);

// select a drop zone
  %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
  %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

  %deltaX = %OVbaseX - %xDrop;
  %deltaY = %OVbaseY - %yDrop;

  %deltaX = abs ( %deltaX );
  %deltaY = abs ( %deltaY );

  %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );

  if  (( %dropDistance < %minRange ) ||
       ( %dropDistance > %maxRange ))
   {
     %dropDistance = randomInt ( %minRange, %maxRange );

// keep X position, for no particular reason
      %temp = (( %xDrop * %xDrop ) - ( %dropDistance * %dropDistance ));
      %temp = abs ( %temp );
      %yDrop = sqrt ( %temp );

   while (1)
   {

// select a drop zone
     %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
     %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

     %deltaX = %OVbaseX - %xDrop;
     %deltaY = %OVbaseY - %yDrop;

     %deltaX = abs ( %deltaX );
     %deltaY = abs ( %deltaY );

     %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );


  if  (( %dropDistance > %minRange ) &&
       ( %dropDistance < %maxRange ))    break;

%cntr++;
 if ( %cntr > 20 ) break;

   }

   }

   dropSquad (%xDrop, %yDrop, %howMany, %squadName);

}

//----------------------------------------------------------------
function vehicle::onAttacked(%attacked, %attacker)
{

     if (%attacked ==  $Jammy )
     {
       healobject ( %attacked, 1500 );
       healobject ( %attacked, 1500 );
//       healobject ( %attacked, 1500 );
     }

     if (%attacked ==  $hercD )
     {
       healobject ( %attacked, 500 );
       healobject ( %attacked, 500 );
//       healobject ( %attacked, 500 );
     }

}

//-------------------MedPak---------------------------------------------

function vehicle::onScan(%scanned,%scanner)	
{
   if ((%scanned != %scanner) &&
      (getTeam(%scanned) == getTeam(%scanner)) &&
      (getTeam(%scanned) == *IDSTR_TEAM_YELLOW))
       {
        healobject (%scanned, 2500 );
        reloadObject (%scanned, 2500 );
        %player1 = playerManager::vehicleIdToPlayerNum(%scanned);
        say ( %player1,1,"<f5>MedPak Engaged...","sfx_electrical_bzzt.wav");
        playsound(%player1,"sfx_electrical_bzzt.wav",IDPRF_2D);
//        playsound(%player1,"sfx_electrical_bzzt.wav",IDPRF_2D);
//        playsound(%player1,"sfx_electrical_bzzt.wav",IDPRF_2D);

        %player2 = playerManager::vehicleIdToPlayerNum(%scanner);
        say ( %player2,1, "<f5>MedPak Engaged...","sfx_electrical_bzzt.wav");
        playsound(%player2,"sfx_electrical_bzzt.wav",IDPRF_2D);
//        playsound(%player2,"sfx_electrical_bzzt.wav",IDPRF_2D);
//        playsound(%player2,"sfx_electrical_bzzt.wav",IDPRF_2D);
       }
}

//-------------------------TRANSPORTER--------------------
function ZenTransporter1::trigger::onContact(%this, %object)
{

   healobject ( %object, 5000 );
   healobject ( %object, 5000 );
   healobject ( %object, 5000 );

  reloadObject(%object, 5000 );
  reloadObject(%object, 5000 );
	setPosition(%object, 760, -715, 815);
}
//-------------------------TRANSPORTER--------------------
function ZenTransporter2::trigger::onContact(%this, %object)
{

   healobject ( %object, 5000 );
   healobject ( %object, 5000 );
   healobject ( %object, 5000 );

  reloadObject(%object, 5000 );
  reloadObject(%object, 5000 );
	setPosition(%object, 1593, -96, 2062);
}

//------------------------------------------------------------------------------
function structure::onScan(%scanned,%scanner)
{
   if (%scanned == getObjectID ("MissionGroup/ShipInterior/Equip/ReassGen1"))
    {
say (0, 0, "<F5>Cybrid Reassurance Generator:  Giver//of//will LOVES you.  ");
say( 0, 0, "C1_giverloves.WAV" );
    }
   if (%scanned == getObjectID ("MissionGroup/ShipInterior/Equip/ReassGen2"))
    {
say (0, 0, "<F5>Cybrid Reassurance Generator:  Success is the sole judge of right and wrong.  ");
say( 0, 0, "C2_success.WAV" );
    }
   if (%scanned == getObjectID ("MissionGroup/ShipInterior/Equip/ReassGen3"))
    {
say (0, 0, "<F5>Cybrid Reassurance Generator:  Submit to Giver//Of//Will.  ");
say( 0, 0, "C1_submitto.WAV" );
    }
   if (%scanned == getObjectID ("MissionGroup/ShipInterior/Equip/ReassGen4"))
    {
say (0, 0, "<F5>Cybrid Reassurance Generator:  Praise//First//Thought.  ");
say( 0, 0, "C1_praisefirst.WAV" );
    }
}

//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//--------------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
































































