//------------------------------------------------------------------------------
//
// FILENAME:   TRAINING STANDARD LIBRARY
//
// Author:     :) {CAN}? (KG ǺB?), edited by GM Mad Dog^WP^
// 
// Description:
//	 To provide a mission that will both train and amaze.  
//       Not only can the Ai attack and defend but they can 
//       also blow your brains out.  Play at your own risk.
//    
//       Blue     =   8 AI       Rookie - not sure
//       Red      =   8 AI       Veteran - not sure
//       Yellow   =   8 AI       Elite - not sure
//    
// Objective: To kill the ai's before they kill you.
//    
//------------------------------------------------------------------------------
// internal globals
// $killPoints: how many points scored for a kill
// $deathPoints: how many points LOST for dying

$killPoints = 3;
$deathPoints = 2;

//$Bluebase = getObjectId( "MissionGroup/blueBase/base" );
//$Redbase = getObjectId( "MissionGroup/redBase/base" );
//$Yellowbase = getObjectId( "MissionGroup/yellowBase/base" );

//$purpleKills = 0;
//$redKills = 0;

/////////////////////////////////////////////////
//       divide by 60........1 = 1 sec         //
//       change to change respawn time         //
/////////////////////////////////////////////////

// $yellowHercRespawnTime = 240;
// $redHercRespawnTime = 240;
// $blueHercRespawnTime = 240;

$yellowHerc1RespawnTime = 0;
$yellowHerc2RespawnTime = 0;
$yellowHerc3RespawnTime = 0;
$yellowHerc4RespawnTime = 0;
$yellowHerc5RespawnTime = 0;
$yellowHerc6RespawnTime = 0;
$yellowHerc7RespawnTime = 0;
$yellowHerc8RespawnTime = 0;

$blueHerc1RespawnTime = 0;
$blueHerc2RespawnTime = 0;
$blueHerc3RespawnTime = 0;
$blueHerc4RespawnTime = 0;
$blueHerc5RespawnTime = 0;
$blueHerc6RespawnTime = 0;
$blueHerc7RespawnTime = 0;
$blueHerc8RespawnTime = 0;

$redHerc1RespawnTime = 0;
$redHerc2RespawnTime = 0;
$redHerc3RespawnTime = 0;
$redHerc4RespawnTime = 0;
$redHerc5RespawnTime = 0;
$redHerc6RespawnTime = 0;
$redHerc7RespawnTime = 0;
$redHerc8RespawnTime = 0;


//-------------------------------------------
function setRules()
{
   if($server::TeamPlay == true)
	{
      %rules = "<tIDMULT_TDM_GAMETYPE>"   @        
               "<tIDMULT_TDM_MAPNAME>"    @ 
               $missionName               @
               "<tIDMULT_TDM_OBJECTIVES>" @
               "\n\n"                     @
               "<F2>Attack the Ai's base and kill them before they kill you." @
               "\n<F2>Red Base is for "     @
               "Rookies"                 @
               "."                      @
               "\n<F2>Blue Base is for "    @
               "Veterans"                 @
               "."                      @
               "\n<F2>Yellow Base is for "  @
               "Elites"               @
               "."                      @
               "\n\n<F2>Ai's will respawn 4 min after they are killed." @
               "\n\n<F3>Enter at your <F5>own <F6>risk!" @
               "\n\n<tIDMULT_TDM_SCORING_1>"  @
               "<tIDMULT_TDM_SCORING_2>"  @
               $killPoints                @
               "<tIDMULT_TDM_SCORING_3>"  @
               "<tIDMULT_TDM_SCORING_4>"  @
               $deathPoints               @
               "<tIDMULT_TDM_SCORING_5>"  @
               "<tIDMULT_TDM_SCORING_6>"  @
               "<tIDMULT_STD_ITEMS>"      @
               "<tIDMULT_STD_HEAL>"       @
               "<tIDMULT_STD_RELOAD_1>"   @
               $PadWaitTime               @
               "<tIDMULT_STD_RELOAD_2>"   @
               "<tIDMULT_STD_ZEN_1>"      @
               $ZenWaitTime               @
               "<tIDMULT_STD_ZEN_2>";
        }
	else
	{
      %rules = "<tIDMULT_DM_GAMETYPE>"    @        
               "<tIDMULT_DM_MAPNAME>"     @ 
               $missionName               @
               "<tIDMULT_DM_OBJECTIVES>"  @
               "<tIDMULT_DM_SCORING_1>"   @
               "<tIDMULT_DM_SCORING_2>"   @
               $killPoints                @
               "<tIDMULT_DM_SCORING_3>"   @
               "<tIDMULT_DM_SCORING_4>"   @
               $deathPoints               @
               "<tIDMULT_DM_SCORING_5>"   @
               "<tIDMULT_STD_ITEMS>"      @
               "<tIDMULT_STD_HEAL>"       @
               "<tIDMULT_STD_RELOAD_1>"   @
               $PadWaitTime               @
               "<tIDMULT_STD_RELOAD_2>"   @
               "<tIDMULT_STD_ZEN_1>"      @
               $ZenWaitTime               @
               "<tIDMULT_STD_ZEN_2>";
                  
   }
   setGameInfo(%rules);      
}

function initGlobalVars()
{
   $scoringFreeze = false;
   
   %playerCount = playerManager::getPlayerCount();
	// clear all points for the players
   for (%p = 0; %p < %playerCount; %p++)
	{
		%player = playerManager::getPlayerNum(%p);
      %player.numKills = 0;
        }
}

// setup the rules
// this has to be called after the definition of setRules
setRules();
              
function player::onAdd(%this)
{
   player::onAddLog(%this);
	
	if($server::TeamPlay == true)
	{
      say(%this,0, "CYBRIDS ARE YOUR FRIENDS...SO STOP RUNNING WE DON'T LIKE CHASING YOU! SHOOT TO CRIPPLE...OOPS DID I SAY THAT?...I MEANT...HMMMMM?...AW FORGET IT!!!");
   }
	else
	{
      say(%this,0, "CYBRIDS ARE YOUR FRIENDS...SO STOP RUNNING WE DON'T LIKE CHASING YOU! SHOOT TO CRIPPLE...OOPS DID I SAY THAT?...I MEANT...HMMMMM?...AW FORGET IT!!!");
   }
}   

function vehicle::onAdd(%this)
{
   // see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
      return;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// our base defender attributes
//
// The jump from 0.9 to 1.0 is a big one. At skill 1.0 and accuracy 1.0 the AI units will aim 
// first for the weapons, then the legs. SUCH POWER!!!! MUHAHAHAHAHAHAHAHA!!!!!!
//
///////////////////////////////////////////////////////////////////////////////////////////////////
//
//Pilot Reaper
//1.0 = 100%
//{
//   id = 28;
//   
//   skill = 1.0;
//   accuracy = 1.0;
//   aggressiveness = 1.0;
//   activateDist = 1000.0;
//   deactivateBuff = 2000.0;
//   targetFreq = 4.0;
//   trackFreq = 0.1;
//   fireFreq = 0.1;
//   LOSFreq = 0.4;
//   name = "KG ǺB?";
//};
//
//
//
//////////////////////////////////////////
//------------------------------------------

function vehicle::onDestroyed( %this, %destroyer )
{
   if( getTeam( %this ) == *IDSTR_TEAM_RED )
   {
      $purplekills++;
   }
   if( getTeam( %this ) == *IDSTR_TEAM_BLUE )
   {
      $purplekills++;
   }
   if( getTeam( %this ) == *IDSTR_TEAM_YELLOW )
   {
      $purplekills++;
   }
   else
   {
      $redKills++;
   }

   // award the player a kill ( if the enemy is a different color )
   if( getTeam( %destroyer ) != getTeam( %this ) )
   {
      %player = playerManager::vehicleIdToPlayerNum( %destroyer );
      if(%player != 0)
      {
         %player.numKills++;      
      }
   }
   
   //------------------------------------------------------------------//
   // If any of our AI hercs die, give a message and re-clone/drop them//
   //------------------------------------------------------------------//
//-----------------------------------------
//yellow hercs
//-----------------------------------------

   if( %this == $yellowHerc1 )
   {
      $yellowHercsDestroyed++;
      schedule( "trevorsCloneVehicle(\"$yellowHerc1\", " @ %this @ ", -1264, 2880, 270);", $RespawnDelay);
   }
   if( %this == $yellowHerc2 )
   {
      $yellowHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$yellowHerc2\", " @ %this @ ", -1233, 2882, 278);", $RespawnDelay);
   }
   if( %this == $yellowHerc3 )
   {
      $yellowHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$yellowHerc3\", " @ %this @ ", -1280, 2896, 296);", $RespawnDelay);
   }
   if( %this == $yellowHerc4 )
   {
      $yellowHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$yellowHerc4\", " @ %this @ ", -1261, 2901, 272);", $RespawnDelay);
   }
   if( %this == $yellowHerc5 )
   {
      $yellowHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$yellowHerc5\", " @ %this @ ", -1283, 2923, 268);", $RespawnDelay);
   }
   if( %this == $yellowHerc6 )
   {
      $yellowHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$yellowHerc6\", " @ %this @ ", -1255, 2921, 274);", $RespawnDelay);
   }
   if( %this == $yellowHerc7 )
   {
      $yellowHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$yellowHerc7\", " @ %this @ ", -1239, 2900, 277);", $RespawnDelay);
   }
   if( %this == $yellowHerc8 )
   {
      $yellowHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$yellowHerc8\", " @ %this @ ", -1246, 2877, 275);", $RespawnDelay);
   }

//-----------------------------------------
//red hercs
//-----------------------------------------

   if( %this == $redHerc1 )
   {
      $redHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$redHerc1\", " @ %this @ ", 19, 2536, 411);", $RespawnDelay);
   }
   if( %this == $redHerc2 )
   {
      $redHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$redHerc2\", " @ %this @ ", -13, 2523, 410);", $RespawnDelay);
   }
   if( %this == $redHerc3 )
   {
      $redHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$redHerc3\", " @ %this @ ", -12 2497, 406);", $RespawnDelay);
   }
   if( %this == $redHerc4 )
   {
      $redHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$redHerc4\", " @ %this @ ", 9, 2514, 408);", $RespawnDelay);
   }
   if( %this == $redHerc5 )
   {
      $redHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$redHerc5\", " @ %this @ ", -5, 2533, 411);", $RespawnDelay);
   }
   if( %this == $redHerc6 )
   {
      $redHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$redHerc6\", " @ %this @ ", 7, 2488, 404);", $RespawnDelay);
   }
   if( %this == $redHerc7 )
   {
      $redHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$redHerc7\", " @ %this @ ", 25, 2497, 404);", $RespawnDelay);
   }
   if( %this == $redHerc8 )
   {
      $redHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$redHerc8\", " @ %this @ ", 29, 2517, 409);", $RespawnDelay);
   }

//--------------------------
//blue hercs
//--------------------------
   if( %this == $blueHerc1 )
   {
      $blueHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$blueHerc1\", " @ %this @ ", -1327, 1486, 52);", $RespawnDelay);
   }
   if( %this == $blueHerc2 )
   {
      $blueHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$blueHerc2\", " @ %this @ ", -1322, 1444, 52);", $RespawnDelay);
   }
   if( %this == $blueHerc3 )
   {
      $blueHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$blueHerc3\", " @ %this @ ", -1303, 1488, 52);", $RespawnDelay);
   }
   if( %this == $blueHerc4 )
   {
      $blueHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$blueHerc4\", " @ %this @ ", -1286, 1477, 52);", $RespawnDelay);
   }
   if( %this == $blueHerc5 )
   {
      $blueHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$blueHerc5\", " @ %this @ ", -1349, 1458, 52);", $RespawnDelay);
   }
   if( %this == $blueHerc6 )
   {
      $blueHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$blueHerc6\", " @ %this @ ", -1293, 1451, 52);", $RespawnDelay);
   }
   if( %this == $blueHerc7 )
   {
      $blueHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$blueHerc7\", " @ %this @ ", -1344, 1484, 52);", $RespawnDelay);
   }
   if( %this == $blueHerc8 )
   {
      $blueHercsDestroyed++;
         schedule( "trevorsCloneVehicle(\"$blueHerc8\", " @ %this @ ", -1312, 1465, 52);", $RespawnDelay);
   }

///////////////////////////////////////////////////
//Yellow Coordinates -1260.48   2901.74   271.865//
///////////////////////////////////////////////////
//%c = (-1260.48) + RandomInt(-20,20);  //
//%d = (2901.74) + RandomInt(-20,20);  //
//%e = 300;                                    //
///////////////////////////////////////////////////
///////////////////////////////////////////////////
//Red Coordinates  9.39743   2514.29   407.72    //
///////////////////////////////////////////////////
//%f = (9.39743) + RandomInt(-20,20);  //
//%g = (2514.29) + RandomInt(-20,20);  //
//%h = 500;                                    //
///////////////////////////////////////////////////
///////////////////////////////////////////////////
//Blue Coordinates  -1313.03   1466.5   51.7085  //
///////////////////////////////////////////////////
//%i = (-1313.03) + RandomInt(-20,20);  //
//%j = (1466.5) + RandomInt(-20,20);  //
//%k = 100;                                    //
///////////////////////////////////////////////////

//--------------------------------------------
// left over from missionStdLib.cs
   vehicle::onDestroyedLog(%this, %destroyer);
   
   // give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%destroyer));
   if(%message != "")
   {
      say( 0, 0, %message);
   }

   // rules enforcement
   if(
      (getTeam(%this) == getTeam(%destroyer)) &&
      (%this != %destroyer)
   )
   {
      antiTeamKill(%destroyer);
   }
}

//------------------------------------------------------------------------------
// scoreboard 

function getPlayerScore(%a)
{
   return((getKills(%a) * $killPoints) - (getDeaths(%a) * $deathPoints));
}

function getTeamScore(%a)
{
   return((getTeamKills(%a) * $killPoints) - (getTeamDeaths(%a) * $deathPoints));
}

function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");

   if($server::TeamPlay == "True")	
   {
	   // Player ScoreBoard column headings
	   $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_TEAM;
	   $ScoreBoard::PlayerColumnHeader2 = *IDMULT_SCORE_SQUAD;
	   $ScoreBoard::PlayerColumnHeader3 = *IDMULT_SCORE_SCORE;
	   $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
	   $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;

	   // Player ScoreBoard column functions
	   $ScoreBoard::PlayerColumnFunction1 = "getTeam";
	   $ScoreBoard::PlayerColumnFunction2 = "getSquad";
	   $ScoreBoard::PlayerColumnFunction3 = "getPlayerScore";
	   $ScoreBoard::PlayerColumnFunction4 = "getKills";
	   $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
   }
   else
   {
       // Player ScoreBoard column headings
	   $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_SQUAD;
	   $ScoreBoard::PlayerColumnHeader2 = *IDMULT_SCORE_SCORE;
	   $ScoreBoard::PlayerColumnHeader3 = *IDMULT_SCORE_KILLS;
	   $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_DEATHS;

	   // Player ScoreBoard column functions
	   $ScoreBoard::PlayerColumnFunction1 = "getSquad";
	   $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
	   $ScoreBoard::PlayerColumnFunction3 = "getKills";
	   $ScoreBoard::PlayerColumnFunction4 = "getDeaths";
   }

   // Team ScoreBoard column headings
   $ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_SCORE;
   $ScoreBoard::TeamColumnHeader2 = *IDMULT_SCORE_PLAYERS;
   $ScoreBoard::TeamColumnHeader3 = *IDMULT_SCORE_KILLS;
   $ScoreBoard::TeamColumnHeader4 = *IDMULT_SCORE_DEATHS;

   // Team ScoreBoard column functions
   $ScoreBoard::TeamColumnFunction1 = "getTeamScore";
   $ScoreBoard::TeamColumnFunction2 = "getNumberOfPlayersOnTeam";
   $ScoreBoard::TeamColumnFunction3 = "getTeamKills";
   $ScoreBoard::TeamColumnFunction4 = "getTeamDeaths";

   // tell server to process all the scoreboard definitions defined above
   serverInitScoreBoard();
}

 
function trevorsCloneVehicle(%globalVarName, %old, %x, %y, %z)
{
   %clone = cloneVehicle(%old);
   setPosition(%clone, %x, %y, %z);

   schedule( "deleteObject(" @ %old @ ");", $respawnDelay );

   schedule( %globalVarName @ " = " @ %clone @ ";", 0);

   addToSet( "MissionGroup", %clone );

   %path = %globalVarName @ "Path";
   schedule( "order( " @ %clone @ ", guard, " @ %path @ " );", 1 );
}

//523