// FILENAME:     Overrun.cs
//
// AUTHOR:       Orogogus
// COMMENTS TO:  h2liu@iname.com
// WEBSITE:      http://home.san.rr.com/orogogus
// LAST UPDATED: 3:41 PM 1/30/00
//------------------------------------------------------------------------------

$missionName = "Overrun";
$nameOfTheGame = "Overrun";

exec("multiplayerStdLib.cs");


function setDefaultMissionOptions()
{
  $server::TeamPlay = true;
  $server::AllowDeathmatch = false;
  $server::AllowTeamPlay = true;  

   // what can the client choose for a team
  $server::AllowTeamRed = false;
  $server::AllowTeamBlue = false;
  $server::AllowTeamYellow = false;
  $server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = true;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = false;
}

function onMissionLoad()
{
}

function setRules()
{
  %rules = "<F2>GAME TYPE: \n<F0>Overrun\n\n" @        
  "<tIDMULT_TDM_MAPNAME>"    @ 
  $missionName               @
  "Use the gray pad to start the game, then try to stay everybody" @
  "<tIDMULT_STD_ITEMS>" ;

   setGameInfo(%rules);      
}


// setup the rules
// this has to be called after the definition of setRules
setRules();


//==============================  global variables

function onMissionStart()
{
  venusSounds();

  $Overrun = 0;
  $maxPlayers = 0;
  $starters = 0;
  $secondsToStart = 10;
  $timeBetweenDrops = 60;
  $attackersPerDrop = 1;
  $attackerCounter = 0;
  $numAttackers = 0;
  $maxAttackers = 10;
  $kills = 0;
  $theLiving = 0;
  $wave = 0;

  $baseX = -1045;
  $baseY = 535;
  $rangeX = 2000;
  $rangeY = 2000;
  $minXRange = 800;
  $minYRange = 800;

  $Starter = "MissionGroup\\Triggers\\Starter";
  $StarterPad = "MissionGroup\\StarterPad";


  // initialize static targets here and set $maxTargets one higher

  $target[0] = getObjectId("MissionGroup\\TargetBuildings\\PurpleHealGenerator");
  %i = $target[0];
  %i.state = "alive";
  $target[1] = getObjectId("MissionGroup\\TargetBuildings\\PurpleAmmoGenerator");
  %i = $target[1];
  %i.state = "alive";
  $target[2] = getObjectId("MissionGroup\\TargetBuildings\\radar");
  %i = $target[2];
  %i.state = "alive";
  runRadar1();

//  $target[2] = getObjectId("MissionGroup\\TargetBuildings\\Turret1");
//  %i = $target[2];
//  %i.state = "alive";
//  $target[3] = getObjectId("MissionGroup\\TargetBuildings\\Turret2");
//  %i = $target[3];
//  %i.state = "alive";
//  $target[4] = getObjectId("MissionGroup\\TargetBuildings\\Turret3");
//  %i = $target[4];
//  %i.state = "alive";

//  Turrets aren't buildings.  I can chalk up 3 wasted hours of debugging to this fact.


  $maxTargets = 3;


  %nowDate = getDate();
  %nowTime = getTime();
  %outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ "server start";
  fileWrite("multiplayer\\serverlog.txt", append, %outputString);

  $startTime = getCurrentTime();
}


function purpleHeal::structure::onDestroyed(%this, %attackerId)
{
   say("everybody", 0, "The healing structure has been destroyed!");
   $target[0].state = "dead";
}

function purpleAmmo::structure::onDestroyed(%this, %attackerId)
{
   say("everybody", 0, "The ammunition structure has been destroyed!");
   $target[1].state = "dead";
}

function Radar::structure::onDestroyed(%this, %attackerId)
{
   say("everybody", 0, "The radar station has been destroyed!");
   $target[2].state = "dead";
}


function runRadar1()
{
  if(Overrun == 3) return;
  if($target[2].state == "dead") return;
  playAnimSequence($target[2], 0, true);
  schedule("runRadar2();", 4);
}
function runRadar2()
{
  if(Overrun == 3) return;
  if($target[2].state == "dead") return;
  playAnimSequence($target[2], 0, false);
  schedule("runRadar1();", 4);
}


Pilot Reaper
{
   id = 28;
   
   skill = 0.9;
   accuracy = 0.9;
   aggressiveness = 0.8;
   activateDist = 200.0;
   deactivateBuff = 300.0;
   targetFreq = 4.0;
   trackFreq = 0.1;
   fireFreq = 0.1;
   LOSFreq = 0.4;
   name = "The Swarm";
};

//===============================


function player::OnAdd(%player)
{
  %player.name = getName(%player);

  %nowDate = getDate();
  %nowTime = getTime();
  %player.IP = getConnection(%player);
  %player.startTime = getCurrentTime();
  %outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ %player.name @ " joined the game (" @ %player.IP @ ")";

  fileWrite("multiplayer\\serverlog.txt", append, %outputString);
}

function player::OnRemove(%player)
{
  %player.name = getName(%player);
  %nowDate = getDate();
  %nowTime = getTime();
  %timeEnd = getCurrentTime();
  %timeIn = timeDifference( %timeEnd, %player.startTime);
  %outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ %player.name @ " left the game (" @ %player.IP @ ") -- " @ %timeIn;

  fileWrite("multiplayer\\serverlog.txt", append, %outputString);
}



function vehicle::onAdd(%vehicle)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicle);
  if(%player == 0) return;

  if($Overrun == 2)
  {
    healObject(%vehicle, -50000);
    say(%player, 0, "Sorry, players cannot join until the next game.");
    return;
  }
  else
  {
     addPlayerArray(%vehicle);
  }
}

function vehicle::onDestroyed( %destroyed, %destroyer )
{
	%player = playerManager::vehicleIdToPlayerNum(%destroyed);
  %killer = playerManager::vehicleIdToPlayerNum(%destroyer);
  %killerName = getHudName(%destroyer);

  if(%player == 0)
  {
    schedule( "deleteObject(" @ %destroyed @ ");", 2 );
    say("everyone", 0, %killerName @ " destroyed one of the Swarm.");
    $kills++;
    $numAttackers--;
    return;
  }

  if($Overrun == 0)
  {
    $maxPlayers--;
    $theLiving--;  
    return;
  }
  if(%destroyed.state != "alive") return;

  $theLiving--;  
  %destroyed.state = "dead";
  say("everybody", 0, %player.name @ " has fallen.");

  if($theLiving <= 0)
  {
    %timeCompleted = (getCurrentTime() - $startTime);
    %timeString = timeDifference(getCurrentTime(), $startTime);

    say("everybody", 0, "");
    say("everybody", 0, "The defenders have been overrun!");
    say("everybody", 0, "This attack lasted " @ %timeString @ " with " @ $kills @ " kills." );

    schedule("endOverrun();", 10);
  }

}


//===============================  functions to start the game


function starter::trigger::onEnter(%this, %object)
{
  $starters++;

  if($Overrun != 0) return;

  $secondsToStart = 10;
  say("everyone", 0, "10 seconds to initiate Overrun");
  setHudTimerAll(10, -1, "Time to initiate Overrun", 1);
  $Overrun = 1;
  schedule("decrementCountdown();", 1);
}

function starter::trigger::onLeave(%this, %object)
{
  if($Overrun == 2) return;

  $starters--;
  if($starters == 0)
  {
    say("everyone", 0, "Overrun aborted!");
    $Overrun = 0;
    setHudTimerAll(0, 0, "", 1);
  }
}

function decrementCountdown()
{
  $secondsToStart--;

  if($secondsToStart <= 0)
  {
    schedule("startOverrun();", 15);
    $Overrun = 2;

    if($maxPlayers == 1) say("everyone", 0, "Overrun begins in fifteen seconds with " @ $maxPlayers @ " player.  Stand ready.");
    else say("everyone", 0, "Overrun begins in fifteen seconds with " @ $maxPlayers @ " players.  Stand ready.");
    setHudTimerAll(0, 0, "", 1);
    setHudTimerAll(15, -1, "Time to Overrun", 1);
    deleteObject($Starter);
    deleteObject($StarterPad);
  }

  if($Overrun == 1) schedule("decrementCountdown();", 1);
}


function startOverrun()
{
  say( "Everyone", 0, "\\execute\\ core directive.", "C1_executecore.WAV" );
  $startTime = getCurrentTime();

  cdAudioCycle("Watching", "Cyberntx", "Cloudburst"); 

  Overrun(1);
}

//=================================  player functions


function addPlayerArray(%vehicle)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicle);
  
  $playerArray[$maxPlayers] = %player;
  $vehicleArray[$maxPlayers] = %vehicle;
  $maxPlayers++;

  $target[$maxTargets] = %vehicle;
  $maxTargets++;
  $theLiving++;
  %vehicle.state = "alive";
}

function setHudTimerAll(%time, %increment, %string, %channel)
{
  for(%i = 0; %i < $maxPlayers; %i++)
  {
    setHudTimer(%time, %increment, %string, %channel, $playerArray[%i]);
  }
}


//================================


function Overrun(%currentWave)
{
  if($Overrun != 2) return;

  $wave++;
  %currentWave = $wave;

  spawnAttacker($attackersPerDrop);
  if($attackersPerDrop < $maxAttackers) $attackersPerDrop++;

  if(($attackersPerDrop >= $maxAttackers) && ($timeBetweenDrops > 5))
     $timeBetweenDrops = $timeBetweenDrops - 5;

  if($timeBetweenDrops <= 5)
  {
    if($rangeX > $minXRange) $rangeX = $rangeX - 50;
    if($rangeY > $minYRange) $rangeY = $rangeY - 50;

    if($rangeX < $minXRange) $rangeX = $minXRange;
    if($rangeY < $minYRange) $rangeY = $minYRange;
  }

  schedule("Overrun(" @ %currentWave @");", $timeBetweenDrops);
}

function spawnAttacker(%counter)
{
  if(Overrun == 3) return;

  if($numAttackers >= $maxAttackers) return;
  Say( "Everyone", 0, "Hurt//maim//kill", "C1_hurtmaimkill.WAV" );

	for ( %i=0; %i<(%counter); %i++ )
	{
    if($numAttackers >= $maxAttackers) return;


    // Cybrids only

    %targType = RandomInt(20,31);
    if ( %targType>28)
     %targType = RandomInt(35,37);

    // get appropriate type Tank or Herc
    %type = Herc;
    if ( %targType == 25  || %targType == 26 )   %type = Tank;


//    All Vehicles
//
//    %spawnNum = RandomInt(1, 31);
//
//    if(%spawnNum == 1) %targType = 1;
//    if(%spawnNum == 2) %targType = 2;
//    if(%spawnNum == 3) %targType = 3;
//    if(%spawnNum == 4) %targType = 4;
//    if(%spawnNum == 5) %targType = 5;
//    if(%spawnNum == 6) %targType = 6;
//    if(%spawnNum == 7) %targType = 7;
//    if(%spawnNum == 8) %targType = 10;
//    if(%spawnNum == 9) %targType = 11;
//    if(%spawnNum == 10) %targType = 12;
//    if(%spawnNum == 11) %targType = 13;
//    if(%spawnNum == 12) %targType = 14;
//    if(%spawnNum == 13) %targType = 15;
//    if(%spawnNum == 14) %targType = 16;
//    if(%spawnNum == 15) %targType = 20;
//    if(%spawnNum == 16) %targType = 21;
//    if(%spawnNum == 17) %targType = 22;
//    if(%spawnNum == 18) %targType = 23;
//    if(%spawnNum == 19) %targType = 24;
//    if(%spawnNum == 20) %targType = 25;
//    if(%spawnNum == 21) %targType = 26;
//    if(%spawnNum == 22) %targType = 27;
//    if(%spawnNum == 23) %targType = 28;
//    if(%spawnNum == 24) %targType = 30;
//    if(%spawnNum == 25) %targType = 31;
//    if(%spawnNum == 26) %targType = 32;
//    if(%spawnNum == 27) %targType = 33;
//    if(%spawnNum == 28) %targType = 35;
//    if(%spawnNum == 29) %targType = 36;
//    if(%spawnNum == 30) %targType = 37;
//    if(%spawnNum == 31) %targType = 41;
//
//		%type = Herc;
//		if ( %targType>5  && %targType<= 8 )   %type = Tank;
//		if ( %targType>14 && %targType<= 17 )  %type = Tank;
//		if ( %targType>24 && %targType<= 26 )  %type = Tank;
//		if ( %targType>30 && %targType<= 32 )  %type = Tank;
//		if ( %targType == 41 )  %type = Tank;

    %herc = NewObject("Swarmer", %type, %targType );

		setTeam( %herc, *IDSTR_TEAM_RED );
		dropAttacker(%herc);
    setPilotId(%herc,28);
    $attacker[$attackerCounter] = %herc;
    $attackerCounter++;
    $numAttackers++;
    addToSet( "MissionCleanup", %herc );

    schedule("initialAttack( " @ %herc @ ");", 12);
  }
}

function initialAttack(%herc)
{
  if(Overrun == 3) return;

  %victim = findNearestFoe(%herc);
  order( %herc, attack, $target[%victim] );
}

function dropAttacker(%herc)
{
//  randomTransport(%herc, -2045, -45, -465, 1535);

  %x1 = $baseX - $rangeX;
  %x2 = $baseX + $rangeX;

  %y1 = $baseY - $rangeY;
  %y2 = $baseY + $rangeY;

  %x = randomInt(%x1, %x2);
  %y = randomInt(%y1, %y2);

  while( ( (%x < ($baseX + $minXRange)) && (%x > ($baseX - $minXRange) ) )
   && ( (%y < ($baseY + $minYRange)) && (%y > ($baseY - $minYRange) ) ) )
  {
    %x = randomInt(%x1, %x2);
    %y = randomInt(%y1, %y2);
  }

  %z = getTerrainHeight(%x, %y);

  dropPod(%x, %y, %z, %herc);
  if($target[2].state == "alive") schedule("reportDrop( " @ %x @ ", " @ %y @ ", " @ %herc @ ");", 10);
}


function reportDrop(%x, %y, %herc)
{
  if(Overrun == 3) return;

  if($target[2].state == "dead") return;
  %x1 = getPosition($target[2], x);
  %y1 = getPosition($target[2], y);

  %howFar = getDistance($target[2], %herc);

  %xcomp = (%x - %x1) / %howfar;
  %ycomp = (%y - %y1) / %howfar;
 
  if( %ycomp >= 0.866 ) %direction = "north";

  if( ( ( %ycomp < 0.866 ) && ( %ycomp > 0 ) ) &&
    ( ( %xcomp < 0.866 ) && ( %xcomp > 0 ) ) )
   %direction = "northeast";

  if( %xcomp >= 0.866 ) %direction = "east";

  if( ( ( %ycomp > -0.866 ) && ( %ycomp < 0 ) ) &&
    ( ( %xcomp < 0.866 ) && ( %xcomp > 0 ) ) )
   %direction = "southeast";

  if( %ycomp <= -0.866 ) %direction = "south";

  if( ( ( %ycomp > -0.866 ) && ( %ycomp < 0 ) ) &&
    ( ( %xcomp > -0.866 ) && ( %xcomp < 0 ) ) )
   %direction = "southwest";

  if( %xcomp <= -0.866 ) %direction = "west";

  if( ( ( %ycomp < 0.866 ) && ( %ycomp > 0 ) ) &&
    ( ( %xcomp > -0.866 ) && ( %xcomp < 0 ) ) )
   %direction = "northwest";

   %howfar2 = round(%howfar);

   say("everyone", 0, "Radar station reports a drop " @ %howFar2 @ "m to the " @ %direction);
}


function round(%num)
{
  %temp1 = 0;
  %temp2 = sqrt((%num)*(%num));
  while(%temp2 > 0)
  {
    %temp2 = %temp2 - 1;
    %temp1++;
    if(%temp2 <= 0) return %temp1;
  }
}


function findNearestFoe(%herc)
{
  %chosenOne = 0;
  %nearest = 9999;

  for(%i=0; %i<$maxTargets; %i++)
  {
    %a = $target[%i];
    if(%a.state == "alive")
    {
      %nearby = getDistance(%herc, %a);
      if(%nearby < %nearest)
      {
        %nearest = %nearby;
        %chosenOne = %i;
      }
    }
  }
  echo(%chosenOne);
  return %chosenOne;
}


function vehicle::OnMessage(%this, %message, %a, %b, %c, %d, %e, %f, %g, %h, %i)
{ 
	%player = playerManager::vehicleIdToPlayerNum(%this);
  if(%player != 0) return;

  if(%message == "TargetDestroyed")
  {
     %targId = findNearestFoe(%this);
     %newTarg = $target[%targId];
     order(%this, attack, %newTarg);
  }
}


//================================

function warning::trigger::onEnter(%this, %object)
{
	%player = playerManager::vehicleIdToPlayerNum(%object);
  if(%player == 0) return;

  say(%player, 0, "Leaving the mission boundary is not allowed.");
  healobject(%object, -50000); 
  say(%player, 0, "Sorry about the abruptness -- will fix that when I get a chance");
}

//================================  Endgame functions

function endOverrun()
{
  $Overrun = 3;

  for(%i=0; %i<$attackerCounter; %i++)
  {
    deleteObject($attacker[%i]);
  }

  deleteobject("MissionCleanup");
  missionEndConditionMet();
}

//===================


