// FILENAME:	TDM_NIFKIN_Cybrids.cs
//
// AUTHORS:  	NIFKIN
//------------------------------------------------------------------------------

$missionName = "TDM_NIFKIN_Cybrids";
$hut = "MissionGroup\\prometheus\\hut";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
newObject( tauntsVol, SimVolume, he3.vol); 



function setDefaultMissionOptions()
{
	$server::TeamPlay = True;
	$server::AllowDeathmatch = False;
	$server::AllowTeamPlay = True;	
	$server::AllowMixedTech =False;
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = false;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = false;

   	$server::disableTeamRed = false;
   	$server::disableTeamBlue = true;
   	$server::disableTeamYellow = false;
   	$server::disableTeamPurple = true;
}

function onMissionLoad()
{
   cdAudioCycle("Purge", "Newtech", "Cyberntx"); 
}

function player::onAdd(%this)
{
   player::onAddLog(%this);
	
	if($server::TeamPlay == true)
	{
      say(%this,0, "<F1>Welcome to my map! This is a cybrid vs human map. If you are looking to even the teams you should note that all human vehicles spawn on yellow, and all cybrid spawn on red..");	      
}

function hut::trigger::onEnter( %this, %object )
{ 
	if( getTeam( %object ) == *IDSTR_TEAM_YELLOW )
	{ 
	playAnimSequence( $hut, 0, true ); 
	say("Everybody", 1, "Pitiful human, you cannot hope to win.", "he3_bad01.WAV");
	}
} 


function vehicle::onAdd(%this)
{
	%player = playerManager::vehicleIdToPlayerNum(%this);
	if(%player == 0)
		return;
	if(getTeam(%this) == *IDSTR_TEAM_RED && getVehicleTechBase(%this) == "H")
	{
		setTeam(%this, *IDSTR_TEAM_YELLOW);
		say(PlayerManager::vehicleIdToPlayerNum(%this), 0,"Human vehicles are on yellow team.","F4_Tiger_brains.WAV");
		redrop(%this);
		schedule( "setEnemyNavPoint(" @ %this @ ");", 1 );
	}
	else if(getTeam(%this) == *IDSTR_TEAM_YELLOW && getVehicleTechBase(%this) == "C")
	{
		setTeam(%this, *IDSTR_TEAM_RED);
		say(PlayerManager::vehicleIdToPlayerNum(%this), 0,"Cybrid vehicles are on red team.","C7_weisyourprog.WAV");
		redrop(%this);
		schedule( "setEnemyNavPoint(" @ %this @ ");", 1 );
	}
}

// move the map
$server::HudMapViewOffsetX = -1500;
$server::HudMapViewOffsetY = 2500;

function onMissionStart()
{
	$healRate = 100;   
	$ammoRate = 3;
   	$padWaitTime = 45;
  	$zenWaitTime = 90;
	
	temperateSounds();
}

// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}
}