// FILENAME:	Tyrant.cs
//
// AUTHORS:  	Chaos Gate by Odipherous; Edited into Tyrant by SoMe1
//------------------------------------------------------------------------------

$missionName = "Tyrant";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

	$server::disableTeamRed = false;
   	$server::disableTeamBlue = false;
   	$server::disableTeamYellow = true;
   	$server::disableTeamPurple = true;
}

function onMissionLoad(){
   cdAudioCycle("Mechsoul", "Watching", "Purge"); 
}

function onMissionStart()
{
	earthquakeSounds();	
}

function player::onAdd(%player)
{
   say(%player, 0, "Welcome to Tyrant. Be careful not to set off the alarm, and please have fun and enjoy. Terrian by Odipherous, map by GoP SoMeOnE.");
   messageBox(%player, "This map requires that you download a new terrain to play. Tyrant's terrian file, Chaos Gate, is available at http://ib.mechnex.net");
}

function live::trigger::OnEnter(%this, %object)
{
	setTeam("MissionGroup\\Tyrant\\T1", *IDSTR_TEAM_PURPLE);
	setTeam("MissionGroup\\Tyrant\\T2", *IDSTR_TEAM_PURPLE);
	setTeam("MissionGroup\\Tyrant\\T3", *IDSTR_TEAM_PURPLE);
	setTeam("MissionGroup\\Tyrant\\T4", *IDSTR_TEAM_PURPLE);
	setTeam("MissionGroup\\Tyrant\\T5", *IDSTR_TEAM_PURPLE);
	say("Everybody", 1, "WARNING: The Tyrant has been activated. Please evacuate the area immediatly. Please alow 3 minutes for deactivation.", "sfx_siren.wav");
	order("MissionGroup/Tyrant", Shutdown, false);
	schedule("makeTurretsNeutral();", 180);
	schedule("EndlessBanter();", 5);
}

function makeTurretsNeutral()
{
	setTeam("MissionGroup\\Tyrant\\T1", 0);
	setTeam("MissionGroup\\Tyrant\\T2", 0);
	setTeam("MissionGroup\\Tyrant\\T3", 0);
	setTeam("MissionGroup\\Tyrant\\T4", 0);
	setTeam("MissionGroup\\Tyrant\\T5", 0);
	say("Everybody", 1, "The Tyrant has been deactivated.", "sfx_siren.wav");
	order("MissionGroup/Tyrant", Shutdown, true);
}

function EndlessBanter(%player)
{
	playSound(0, "SM_Riana_HT1.wav", IDPRF_2D);
	schedule("playSound(0, \"CA0_WST03.wav\", IDPRF_2D);", 5);
	schedule("playSound(0, \"CA0_STP03.wav\", IDPRF_2D);", 10);
	schedule("playSound(0, \"CA0_STP06.wav\", IDPRF_2D);", 15);
	schedule("playSound(0, \"CA0_BLU07.wav\", IDPRF_2D);", 20);
	schedule("playSound(0, \"CA0_STP07.wav\", IDPRF_2D);", 25);
	schedule("playSound(0, \"SFX_FOG.WAV\", IDPRF_2D);", 30);
	schedule("playSound(0, \"CA0_WST07.wav\", IDPRF_2D);", 35);
	schedule("playSound(0, \"CYB_ME10.wav\", IDPRF_2D);", 40);
	schedule("playSound(0, \"CYB_GN57.wav\", IDPRF_2D);", 45);
	schedule("playSound(0, \"CA0_STP08.wav\", IDPRF_2D);", 50);
}